"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var upath_1 = require("upath");
var argumenter_1 = require("@joejukan/argumenter");
var enumeration_1 = require("../enumeration");
var REGEX_VUE = /\.vue$/i;
var DependencyClass = /** @class */ (function () {
    function DependencyClass() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var argue = new argumenter_1.Argumenter(args);
        this.name = argue.string;
        this.symbol = argue.string;
        this.path = argue.string;
        this.type = argue.number || enumeration_1.DependencyType.VUE;
        this.defaulted = argue.boolean || false;
    }
    DependencyClass.prototype.relative = function (path) {
        var from = path_1.posix.dirname(upath_1.normalize(path));
        var to = upath_1.normalize(this.path);
        var p = path_1.posix.relative(from, to);
        // TODO: evaluate if module
        if (p.match(REGEX_VUE) && !p.match(/^\.+\//)) {
            p = "./" + p;
        }
        return p;
    };
    return DependencyClass;
}());
exports.DependencyClass = DependencyClass;
//# sourceMappingURL=dependency.class.js.map